// vim:expandtab:shiftwidth=2:tabstop=2:
// Copyright (C) 2013 Canonical Ltd.

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef _OXIDE_SHARED_COMMON_CONTENT_CLIENT_H_
#define _OXIDE_SHARED_COMMON_CONTENT_CLIENT_H_

#include <string>

#include "base/basictypes.h"
#include "base/compiler_specific.h"
#include "content/public/common/content_client.h"

namespace oxide {

class ContentBrowserClient;
class ContentRendererClient;

class ContentClient : public content::ContentClient {
 public:
  static ContentClient* instance();
  virtual ~ContentClient();

  ContentBrowserClient* browser();
  ContentRendererClient* renderer();

  virtual intptr_t GetNativeDisplay() = 0;

 protected:
  ContentClient();

 private:
  void AddPepperPlugins(std::vector<content::PepperPluginInfo>* plugins) FINAL;

  std::string GetUserAgent() const FINAL;

  base::string16 GetLocalizedString(int message_id) const FINAL;

  DISALLOW_COPY_AND_ASSIGN(ContentClient);
};

} // namespace oxide

#endif // _OXIDE_SHARED_COMMON_CONTENT_CLIENT_H_
